var keyword = "",
    wordList = "list going fine",
    inputField = document.getElementById("keyword"),
    suggestionField = document.getElementById("suggestion"),
    outputList = document.getElementById("output-list");


inputField.addEventListener("keyup", function(event){
    var code = event.keyCode,
        suggestion;

   keyword = inputField.value.trim();

    // Get suggestion
    suggestion = autoCompleteModified(keyword, wordList);

    // Add suggestion to suggestion field
    if (suggestion !== undefined) {
        suggestionField.innerHTML = suggestion;
    } else {
        suggestionField.innerHTML = "";
    }

    // space - autocomplete field
    if (code == 32) {
        if (suggestion !== undefined) {
            inputField.value = keyword + suggestion.slice(keyword.length) + " ";
            keyword = suggestion;
        }
    }
    // enter - add word to list
    if (code == 13) {
        addToList(keyword);
        keyword =  "";
        inputField.value = "";
        suggestionField.innerHTML = "";
    }
});

function addToList(item) {
    var li = document.createElement("li");
    li.innerHTML = item;
    outputList.appendChild(li);
}

function autoCompleteModified(keyword, text) {
    var words = text.split(" ");

    var possibleWords = [];

    for (var j = 0; j < words.length; j++) {
        var currentWord = words[j];
        if (currentWord.toLowerCase()
            .indexOf(keyword.toLowerCase()) === 0) {
            possibleWords.push(currentWord);
        }
    }

    if (possibleWords.length > 0) {
        var bestWord = possibleWords.sort(function(s1, s2) {
            if (s1.length === s2.length) {
                return s1.localeCompare(s2);
            }
            return s1.length - s2.length;
        })[0];
        return bestWord;
    } else {
        return undefined;
    }
}